/etc/init/failsafe.conf doesn't actually stop on runlevel

Bug #863864 reported by Steve Langasek on 2011-10-01
6
This bug affects 1 person
Affects Status Importance Assigned to Milestone
upstart (Ubuntu)
High
Clint Byrum

Bug Description

The failsafe job is meant to inform the user that the system is waiting for the network to come up, and start the runlevel if a timeout is reached.

However, the 'stop on runlevel' does *not* work as designed, because all the activity here is done in the pre-start script which upstart will not kill when the job target changes to stop:

$ sudo start failsafe&
[1] 3979
vorlon@nvidia-8600m:~$ status failsafe
failsafe start/pre-start, process 3981
vorlon@nvidia-8600m:~$ sudo stop failsafe&
[2] 3985
vorlon@nvidia-8600m:~$ status failsafefailsafe stop/pre-start, process 3981

failsafe stop/pre-start, process 3981
[1]- Done sudo start failsafe

So the pre-start script continues sleeping, and continues sending messages to plymouth.

If you happen to reboot the system within two minutes of startup, this results in the messages being printed on the splash screen at *shutdown*, which is rather confusing.

To avoid this, I think the failsafe job should be switched to do its work in 'script' instead of 'pre-start script', and rc-sysinit changed to listen for an event emitted by the failsafe job at the end of this script instead of on 'started failsafe'.

ProblemType: Bug
DistroRelease: Ubuntu 11.10
Package: upstart 1.3-0ubuntu9
ProcVersionSignature: Ubuntu 3.0.0-12.19-generic 3.0.4
Uname: Linux 3.0.0-12-generic x86_64
NonfreeKernelModules: nvidia
ApportVersion: 1.23-0ubuntu2
Architecture: amd64
Date: Sat Oct 1 00:02:54 2011
InstallationMedia: Ubuntu 10.04 "Lucid Lynx" - Beta amd64 (20100406.1)
ProcEnviron:
 LANG=en_US.UTF-8
 SHELL=/bin/bash
SourcePackage: upstart
UpgradeStatus: Upgraded to oneiric on 2011-09-23 (7 days ago)
modified.conffile..etc.init.tty2.conf: [modified]
mtime.conffile..etc.init.tty2.conf: 2010-04-18T00:37:33.806038

Related branches

Steve Langasek (vorlon) wrote :
Changed in upstart (Ubuntu):
status: New → Triaged
importance: Undecided → Medium
Steve Langasek (vorlon) on 2011-10-03
Changed in upstart (Ubuntu):
assignee: nobody → Clint Byrum (clint-fewbar)
Clint Byrum (clint-fewbar) wrote :

Raised to High, this also causes odd problems with plymouth in boot, and shows the message if lightdm takes more than 20 seconds.

Changed in upstart (Ubuntu):
importance: Medium → High
milestone: none → ubuntu-11.10
Changed in upstart (Ubuntu):
status: Triaged → Fix Committed
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package upstart - 1.3-0ubuntu10

---------------
upstart (1.3-0ubuntu10) oneiric; urgency=low

  [ Clint Byrum ]
  * debian/conf/failsafe.conf: do delay as script, not pre-start, so
    that the messages/delays are stopped on runlevel immediately. emit
    as an event, failsafe-boot, to provide finer grained control.
    (LP: #863864)
  * conf/rc-sysinit.conf: change from 'started failsafe' to 'failsafe-boot'
    to accomodate changes to failsafe.conf.

  [ Steve Langasek ]
  * Document device-not-ready in upstart-events(7). LP: #805510.
  * Document desktop-shutdown in upstart-events(7). LP: #854329.
  * Mention lightdm in the list of example DMs in upstart-events(7), since
    it's now the default...
 -- Steve Langasek <email address hidden> Mon, 03 Oct 2011 18:37:04 -0700

Changed in upstart (Ubuntu):
status: Fix Committed → Fix Released
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers